import logging
import optparse

import urllib2
from BeautifulSoup import BeautifulSoup

import gettext
from gettext import gettext as _
gettext.textdomain('pythondoc-lens')

from singlet.lens import SingleScopeLens, IconViewCategory, ListViewCategory

from pythondoc_lens import pythondoc_lensconfig

class PythondocLens(SingleScopeLens):

    class Meta:
        name = 'pythondoc'
        description = 'Pythondoc Lens'
        search_hint = 'Search Pythondoc'
        icon = 'pythondoc.svg'
        search_on_blank=True

    # Pablo Code
    pythondoc_category = IconViewCategory("Python Docs", 'help')
    doc = 'http://docs.python.org/'
    shows = {}

    def search(self, search, results):
        '''Metodo que busca'''

        for text, url in self.pythondoc(search):
            results.append(url,
            ('file:///usr/share/unity/lenses/'
             'pythondoc/unity-lens-pythondoc.svg'),
             self.pythondoc_category,
             "text/html",
             text,
             'docs.python.org',
             url)
        pass

    def pythondoc(self, search):
        '''El Metodo que busca'''
        results = []
        if not search:
            return results
        print 'Searching for:', search
        if not self.shows:
            url = self.doc + 'genindex-all.html'
            page = urllib2.urlopen(url).read()
            soup = BeautifulSoup(page)
            tds = soup.findAll('dt')
            for td in tds:
                a = td.find('a')
                if a is None:
                    continue
                url = a.attrs[0][1]
                if url.startswith('/'):
                    url = url[1:]
                url = self.doc + url
                self.shows[a.text.lower()] = url

        search = unicode(search)
        selected = [show for show in self.shows if show.startswith(search)]
        for name in selected:
            results.append((name, self.shows[name]))

        return results